=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/$/.asc/" \
 https://github.com/mupen64plus/mupen64plus-rsp-hle/releases \
	/mupen64plus/mupen64plus-rsp-hle/releases/download/[^/]+/mupen64plus-rsp-hle-src-(.*\d).tar.gz
